1 # SPDX-License-Identifier: GPL-2.0+
5 MIRROR_DOCKER: docker.io
12 # Grab our configured image. The source for this is found
13 # in the u-boot tree at tools/docker/Dockerfile
14 image: ${MIRROR_DOCKER}/trini/u-boot-gitlab-ci-runner:jammy-20240808-21Aug2024
16 # We run some tests in different order, to catch some failures quicker.
23 .buildman_and_testpy_template: &buildman_and_testpy_dfn
25 retry: 2 # QEMU may be too slow, etc.
29 # Clone uboot-test-hooks
30 - git config --global --add safe.directory "${CI_PROJECT_DIR}"
31 - git clone --depth=1 https://source.denx.de/u-boot/u-boot-test-hooks /tmp/uboot-test-hooks
32 # qemu_arm64_lwip_defconfig is the same as qemu_arm64 but with NET_LWIP enabled.
33 # The test config and the boardenv file from qemu_arm64 can be re-used so create symlinks
34 - ln -s conf.qemu_arm64_na /tmp/uboot-test-hooks/bin/travis-ci/conf.qemu_arm64_lwip_na
35 - ln -s travis-ci /tmp/uboot-test-hooks/bin/`hostname`
36 - ln -s travis-ci /tmp/uboot-test-hooks/py/`hostname`
37 - grub-mkimage --prefix="" -o ~/grub_x86.efi -O i386-efi normal echo lsefimmap lsefi lsefisystab efinet tftp minicmd
38 - grub-mkimage --prefix="" -o ~/grub_x64.efi -O x86_64-efi normal echo lsefimmap lsefi lsefisystab efinet tftp minicmd
39 - if [[ "${TEST_PY_BD}" == "qemu-riscv32_spl" ]]; then
40 wget -O - https://github.com/riscv-software-src/opensbi/releases/download/v1.3.1/opensbi-1.3.1-rv-bin.tar.xz | tar -C /tmp -xJ;
41 export OPENSBI=/tmp/opensbi-1.3.1-rv-bin/share/opensbi/ilp32/generic/firmware/fw_dynamic.bin;
43 - if [[ "${TEST_PY_BD}" == "qemu-riscv64_spl" ]] || [[ "${TEST_PY_BD}" == "sifive_unleashed" ]]; then
44 wget -O - https://github.com/riscv-software-src/opensbi/releases/download/v1.3.1/opensbi-1.3.1-rv-bin.tar.xz | tar -C /tmp -xJ;
45 export OPENSBI=/tmp/opensbi-1.3.1-rv-bin/share/opensbi/lp64/generic/firmware/fw_dynamic.bin;
47 - if [[ "${TEST_PY_BD}" == "qemu-arm-sbsa" ]]; then
48 wget -O /tmp/bl1.bin https://artifacts.codelinaro.org/artifactory/linaro-419-sbsa-ref/latest/tf-a/bl1.bin;
49 wget -O /tmp/fip.bin https://artifacts.codelinaro.org/artifactory/linaro-419-sbsa-ref/latest/tf-a/fip.bin;
50 export BINMAN_INDIRS=/tmp;
54 - cp -v /tmp/${TEST_PY_BD}/*.{html,css,xml} .
55 - rm -rf /tmp/uboot-test-hooks /tmp/venv
57 # If we've been asked to use clang only do one configuration.
58 - export UBOOT_TRAVIS_BUILD_DIR=/tmp/${TEST_PY_BD}
59 - echo BUILD_ENV ${BUILD_ENV}
60 - if [ -n "${BUILD_ENV}" ]; then
63 - tools/buildman/buildman -o ${UBOOT_TRAVIS_BUILD_DIR} -w -E -W -e
64 --board ${TEST_PY_BD} ${OVERRIDE}
65 - cp ~/grub_x86.efi $UBOOT_TRAVIS_BUILD_DIR/
66 - cp ~/grub_x64.efi $UBOOT_TRAVIS_BUILD_DIR/
67 - cp /opt/grub/grubriscv64.efi $UBOOT_TRAVIS_BUILD_DIR/grub_riscv64.efi
68 - cp /opt/grub/grubaa64.efi $UBOOT_TRAVIS_BUILD_DIR/grub_arm64.efi
69 - cp /opt/grub/grubarm.efi $UBOOT_TRAVIS_BUILD_DIR/grub_arm.efi
70 # create sdcard / spi-nor images for sifive unleashed using genimage
71 - if [[ "${TEST_PY_BD}" == "sifive_unleashed" ]]; then
73 cp ${UBOOT_TRAVIS_BUILD_DIR}/spl/u-boot-spl.bin .;
74 cp ${UBOOT_TRAVIS_BUILD_DIR}/u-boot.itb .;
76 genimage --inputpath . --config board/sifive/unleashed/genimage_sdcard.cfg;
77 cp images/sdcard.img ${UBOOT_TRAVIS_BUILD_DIR}/;
79 genimage --inputpath . --config board/sifive/unleashed/genimage_spi-nor.cfg;
80 cp images/spi-nor.img ${UBOOT_TRAVIS_BUILD_DIR}/;
82 - if [[ "${TEST_PY_BD}" == "coreboot" ]]; then
83 cp /opt/coreboot/coreboot.rom ${UBOOT_TRAVIS_BUILD_DIR}/coreboot.rom;
84 /opt/coreboot/cbfstool ${UBOOT_TRAVIS_BUILD_DIR}/coreboot.rom remove -n fallback/payload;
85 /opt/coreboot/cbfstool ${UBOOT_TRAVIS_BUILD_DIR}/coreboot.rom add-flat-binary -f ${UBOOT_TRAVIS_BUILD_DIR}/u-boot.bin -n fallback/payload -c LZMA -l 0x1110000 -e 0x1110000;
87 - virtualenv -p /usr/bin/python3 /tmp/venv
88 - . /tmp/venv/bin/activate
89 - pip install -r test/py/requirements.txt
90 # "${var:+"-k $var"}" expands to "" if $var is empty, "-k $var" if not
91 - export PATH=/opt/qemu/bin:/tmp/uboot-test-hooks/bin:${PATH};
92 export PYTHONPATH=/tmp/uboot-test-hooks/py/travis-ci;
93 ./test/py/test.py -ra --bd ${TEST_PY_BD} ${TEST_PY_ID}
94 ${TEST_PY_TEST_SPEC:+"-k ${TEST_PY_TEST_SPEC}"}
95 --build-dir "$UBOOT_TRAVIS_BUILD_DIR"
96 --junitxml=/tmp/${TEST_PY_BD}/results.xml
111 build all 32bit ARM platforms:
112 extends: .world_build
115 git config --global --add safe.directory "${CI_PROJECT_DIR}";
116 pip install -r tools/buildman/requirements.txt;
117 ./tools/buildman/buildman -o /tmp -PEWM arm -x aarch64 || ret=$?;
118 if [[ $ret -ne 0 ]]; then
119 ./tools/buildman/buildman -o /tmp -seP;
123 build all 64bit ARM platforms:
124 extends: .world_build
126 - virtualenv -p /usr/bin/python3 /tmp/venv
127 - . /tmp/venv/bin/activate
129 git config --global --add safe.directory "${CI_PROJECT_DIR}";
130 pip install -r tools/buildman/requirements.txt;
131 ./tools/buildman/buildman -o /tmp -PEWM aarch64 || ret=$?;
132 if [[ $ret -ne 0 ]]; then
133 ./tools/buildman/buildman -o /tmp -seP;
137 build all PowerPC platforms:
138 extends: .world_build
141 git config --global --add safe.directory "${CI_PROJECT_DIR}";
142 ./tools/buildman/buildman -o /tmp -P -E -W powerpc || ret=$?;
143 if [[ $ret -ne 0 ]]; then
144 ./tools/buildman/buildman -o /tmp -seP;
148 build all other platforms:
149 extends: .world_build
152 git config --global --add safe.directory "${CI_PROJECT_DIR}";
153 ./tools/buildman/buildman -o /tmp -PEWM -x arm,powerpc || ret=$?;
154 if [[ $ret -ne 0 ]]; then
155 ./tools/buildman/buildman -o /tmp -seP;
164 check for new CONFIG symbols outside Kconfig:
167 - git config --global --add safe.directory "${CI_PROJECT_DIR}"
168 # If grep succeeds and finds a match the test fails as we should
170 - git grep -E '^#[[:blank:]]*(define|undef)[[:blank:]]*CONFIG_'
171 :^doc/ :^arch/arm/dts/ :^scripts/kconfig/lkc.h
172 :^include/linux/kconfig.h :^tools/ :^dts/upstream/
173 :^lib/mbedtls/external :^lib/mbedtls/mbedtls_def_config.h &&
176 # build documentation
180 - virtualenv -p /usr/bin/python3 /tmp/venvhtml
181 - . /tmp/venvhtml/bin/activate
182 - pip install -r doc/sphinx/requirements.txt
183 - make htmldocs KDOC_WERROR=1
186 # ensure all configs have MAINTAINERS entries
187 Check for configs without MAINTAINERS entry:
190 - ./tools/buildman/buildman --maintainer-check
192 # Ensure host tools build
193 Build tools-only and envtools:
196 - make tools-only_config tools-only -j$(nproc);
198 make tools-only_config envtools -j$(nproc)
200 Run binman, buildman, dtoc, Kconfig and patman testsuites:
203 - git config --global user.name "GitLab CI Runner";
205 git config --global --add safe.directory "${CI_PROJECT_DIR}";
207 virtualenv -p /usr/bin/python3 /tmp/venv;
208 . /tmp/venv/bin/activate;
209 pip install -r test/py/requirements.txt;
210 pip install -r tools/buildman/requirements.txt;
211 export UBOOT_TRAVIS_BUILD_DIR=/tmp/tools-only;
212 export PYTHONPATH="${UBOOT_TRAVIS_BUILD_DIR}/scripts/dtc/pylibfdt";
213 export PATH="${UBOOT_TRAVIS_BUILD_DIR}/scripts/dtc:${PATH}";
215 ./tools/buildman/buildman -T0 -o ${UBOOT_TRAVIS_BUILD_DIR} -w
218 ./tools/binman/binman --toolpath ${UBOOT_TRAVIS_BUILD_DIR}/tools test;
219 ./tools/buildman/buildman -t;
220 ./tools/dtoc/dtoc -t;
221 ./tools/patman/patman test;
224 # Check for any pylint regressions
228 - git config --global --add safe.directory "${CI_PROJECT_DIR}"
229 - pip install -r test/py/requirements.txt
230 - pip install -r tools/buildman/requirements.txt
231 - pip install asteval pylint==2.12.2 pyopenssl
232 - export PATH=${PATH}:~/.local/bin
233 - echo "[MASTER]" >> .pylintrc
234 - echo "load-plugins=pylint.extensions.docparams" >> .pylintrc
235 - export UBOOT_TRAVIS_BUILD_DIR=/tmp/tools-only
237 - ./tools/buildman/buildman -T0 -o ${UBOOT_TRAVIS_BUILD_DIR} -w
241 - export PYTHONPATH="${UBOOT_TRAVIS_BUILD_DIR}/scripts/dtc/pylibfdt"
244 # Check for pre-schema driver model tags
245 Check for pre-schema tags:
248 - git config --global --add safe.directory "${CI_PROJECT_DIR}";
249 # If grep succeeds and finds a match the test fails as we should
251 - git grep u-boot,dm- -- '*.dts*' && exit 1 || exit 0
253 # Check we can package the Python tools
254 Check packing of Python tools:
259 # Test sandbox with test.py
262 TEST_PY_BD: "sandbox"
263 <<: *buildman_and_testpy_dfn
265 sandbox with clang test.py:
267 TEST_PY_BD: "sandbox"
268 OVERRIDE: "-O clang-17"
269 <<: *buildman_and_testpy_dfn
273 TEST_PY_BD: "sandbox64"
274 <<: *buildman_and_testpy_dfn
276 sandbox64 with clang test.py:
278 TEST_PY_BD: "sandbox64"
279 OVERRIDE: "-O clang-17"
280 <<: *buildman_and_testpy_dfn
284 TEST_PY_BD: "sandbox_spl"
285 TEST_PY_TEST_SPEC: "test_ofplatdata or test_handoff or test_spl"
286 <<: *buildman_and_testpy_dfn
288 sandbox_noinst_test.py:
290 TEST_PY_BD: "sandbox_noinst"
291 TEST_PY_TEST_SPEC: "test_ofplatdata or test_handoff or test_spl"
292 <<: *buildman_and_testpy_dfn
294 sandbox_noinst with LOAD_FIT_FULL test.py:
296 TEST_PY_BD: "sandbox_noinst"
297 TEST_PY_TEST_SPEC: "test_ofplatdata or test_handoff or test_spl"
298 OVERRIDE: "-a CONFIG_SPL_LOAD_FIT_FULL=y"
299 <<: *buildman_and_testpy_dfn
303 TEST_PY_BD: "sandbox_vpl"
304 TEST_PY_TEST_SPEC: "vpl or test_spl"
305 <<: *buildman_and_testpy_dfn
307 # Enable tracing and disable LTO, to ensure functions are not elided
308 sandbox trace_test.py:
310 TEST_PY_BD: "sandbox"
311 BUILD_ENV: "FTRACE=1 NO_LTO=1"
312 TEST_PY_TEST_SPEC: "trace"
313 OVERRIDE: "-a CONFIG_TRACE=y -a CONFIG_TRACE_EARLY=y -a CONFIG_TRACE_EARLY_SIZE=0x01000000 -a CONFIG_TRACE_BUFFER_SIZE=0x02000000"
314 <<: *buildman_and_testpy_dfn
318 TEST_PY_BD: "evb-ast2500"
319 TEST_PY_TEST_SPEC: "not sleep"
320 TEST_PY_ID: "--id qemu"
321 <<: *buildman_and_testpy_dfn
325 TEST_PY_BD: "evb-ast2600"
326 TEST_PY_TEST_SPEC: "not sleep"
327 TEST_PY_ID: "--id qemu"
328 <<: *buildman_and_testpy_dfn
330 sandbox_flattree test.py:
332 TEST_PY_BD: "sandbox_flattree"
333 <<: *buildman_and_testpy_dfn
335 vexpress_ca9x4 test.py:
337 TEST_PY_BD: "vexpress_ca9x4"
338 TEST_PY_TEST_SPEC: "not sleep"
339 TEST_PY_ID: "--id qemu"
340 <<: *buildman_and_testpy_dfn
342 integratorcp_cm926ejs test.py:
344 TEST_PY_BD: "integratorcp_cm926ejs"
345 TEST_PY_TEST_SPEC: "not sleep"
346 TEST_PY_ID: "--id qemu"
347 <<: *buildman_and_testpy_dfn
351 TEST_PY_BD: "qemu_arm"
352 TEST_PY_TEST_SPEC: "not sleep"
353 <<: *buildman_and_testpy_dfn
357 TEST_PY_BD: "qemu_arm64"
358 TEST_PY_TEST_SPEC: "not sleep"
359 <<: *buildman_and_testpy_dfn
361 qemu_arm64_lwip test.py:
363 TEST_PY_BD: "qemu_arm64_lwip"
364 TEST_PY_TEST_SPEC: "test_net_dhcp or test_net_ping or test_net_tftpboot"
365 <<: *buildman_and_testpy_dfn
367 qemu_arm_sbsa test.py:
369 TEST_PY_BD: "qemu-arm-sbsa"
370 TEST_PY_TEST_SPEC: "not sleep"
371 <<: *buildman_and_testpy_dfn
375 TEST_PY_BD: "M5208EVBE"
376 TEST_PY_ID: "--id qemu"
377 TEST_PY_TEST_SPEC: "not sleep and not efi"
378 OVERRIDE: "-a CONFIG_M68K_QEMU=y -a ~CONFIG_MCFTMR"
379 <<: *buildman_and_testpy_dfn
384 TEST_PY_TEST_SPEC: "not sleep and not efi"
385 TEST_PY_ID: "--id qemu"
386 <<: *buildman_and_testpy_dfn
388 qemu_maltael test.py:
390 TEST_PY_BD: "maltael"
391 TEST_PY_TEST_SPEC: "not sleep and not efi"
392 TEST_PY_ID: "--id qemu"
393 <<: *buildman_and_testpy_dfn
395 qemu_malta64 test.py:
397 TEST_PY_BD: "malta64"
398 TEST_PY_TEST_SPEC: "not sleep and not efi"
399 TEST_PY_ID: "--id qemu"
400 <<: *buildman_and_testpy_dfn
402 qemu_malta64el test.py:
404 TEST_PY_BD: "malta64el"
405 TEST_PY_TEST_SPEC: "not sleep and not efi"
406 TEST_PY_ID: "--id qemu"
407 <<: *buildman_and_testpy_dfn
409 qemu-ppce500 test.py:
411 TEST_PY_BD: "qemu-ppce500"
412 TEST_PY_TEST_SPEC: "not sleep"
413 <<: *buildman_and_testpy_dfn
415 qemu-riscv32 test.py:
417 TEST_PY_BD: "qemu-riscv32"
418 TEST_PY_TEST_SPEC: "not sleep"
419 <<: *buildman_and_testpy_dfn
421 qemu-riscv64 test.py:
423 TEST_PY_BD: "qemu-riscv64"
424 TEST_PY_TEST_SPEC: "not sleep"
425 <<: *buildman_and_testpy_dfn
427 qemu-riscv32_spl test.py:
429 TEST_PY_BD: "qemu-riscv32_spl"
430 TEST_PY_TEST_SPEC: "not sleep"
431 <<: *buildman_and_testpy_dfn
433 qemu-riscv64_spl test.py:
435 TEST_PY_BD: "qemu-riscv64_spl"
436 TEST_PY_TEST_SPEC: "not sleep"
437 <<: *buildman_and_testpy_dfn
441 TEST_PY_BD: "qemu-x86"
442 TEST_PY_TEST_SPEC: "not sleep"
443 <<: *buildman_and_testpy_dfn
447 TEST_PY_BD: "qemu-x86_64"
448 TEST_PY_TEST_SPEC: "not sleep"
449 <<: *buildman_and_testpy_dfn
451 qemu-xtensa-dc233c test.py:
453 TEST_PY_BD: "qemu-xtensa-dc233c"
454 TEST_PY_TEST_SPEC: "not sleep and not efi"
455 <<: *buildman_and_testpy_dfn
457 r2dplus_i82557c test.py:
459 TEST_PY_BD: "r2dplus"
460 TEST_PY_TEST_SPEC: "not sleep"
461 TEST_PY_ID: "--id i82557c_qemu"
462 <<: *buildman_and_testpy_dfn
464 r2dplus_pcnet test.py:
466 TEST_PY_BD: "r2dplus"
467 TEST_PY_TEST_SPEC: "not sleep"
468 TEST_PY_ID: "--id pcnet_qemu"
469 <<: *buildman_and_testpy_dfn
471 r2dplus_rtl8139 test.py:
473 TEST_PY_BD: "r2dplus"
474 TEST_PY_TEST_SPEC: "not sleep"
475 TEST_PY_ID: "--id rtl8139_qemu"
476 <<: *buildman_and_testpy_dfn
478 r2dplus_tulip test.py:
480 TEST_PY_BD: "r2dplus"
481 TEST_PY_TEST_SPEC: "not sleep"
482 TEST_PY_ID: "--id tulip_qemu"
483 <<: *buildman_and_testpy_dfn
485 sifive_unleashed_sdcard test.py:
487 TEST_PY_BD: "sifive_unleashed"
488 TEST_PY_TEST_SPEC: "not sleep"
489 TEST_PY_ID: "--id sdcard_qemu"
490 <<: *buildman_and_testpy_dfn
492 sifive_unleashed_spi-nor test.py:
494 TEST_PY_BD: "sifive_unleashed"
495 TEST_PY_TEST_SPEC: "not sleep"
496 TEST_PY_ID: "--id spi-nor_qemu"
497 <<: *buildman_and_testpy_dfn
499 xilinx_zynq_virt test.py:
501 TEST_PY_BD: "xilinx_zynq_virt"
502 TEST_PY_TEST_SPEC: "not sleep"
503 TEST_PY_ID: "--id qemu"
504 <<: *buildman_and_testpy_dfn
506 xilinx_versal_virt test.py:
508 TEST_PY_BD: "xilinx_versal_virt"
509 TEST_PY_TEST_SPEC: "not sleep"
510 TEST_PY_ID: "--id qemu"
511 <<: *buildman_and_testpy_dfn
516 TEST_PY_TEST_SPEC: "not sleep"
517 TEST_PY_ID: "--id qemu"
518 <<: *buildman_and_testpy_dfn
522 TEST_PY_BD: "coreboot"
523 TEST_PY_TEST_SPEC: "not sleep"
524 TEST_PY_ID: "--id qemu"
525 <<: *buildman_and_testpy_dfn
527 .lab_template: &lab_dfn
530 - if: $SJG_LAB == "1"
532 - if: $SJG_LAB != "1"
537 - if [[ -z "${SJG_LAB}" ]]; then
542 # OUT - output directory for builds
543 - export SRC="$(pwd)"
544 - export OUT="${SRC}/build/${BOARD}"
545 - export PATH=$PATH:~/bin
546 - export PATH=$PATH:/vid/software/devel/ubtest/u-boot-test-hooks/bin
548 # Load it on the device
550 - echo "role ${ROLE}"
551 - export strategy="-s uboot -e off"
552 - export USE_LABGRID_SJG=1
553 # export verbose="-v"
554 - ${SRC}/test/py/test.py --role ${ROLE} --build-dir "${OUT}"
555 --capture=tee-sys -k "not bootstd" || ret=$?
556 - U_BOOT_BOARD_IDENTITY="${ROLE}" u-boot-test-release || true
557 - if [[ $ret -ne 0 ]]; then
563 - "build/${BOARD}/test-log.html"
564 - "build/${BOARD}/multiplexed_log.css"